// Israeli-Jalfon self stabilising algorithm
// dxp/gxn 10/06/02

dtmc

const int k;
const double p1;
const double p2;
const double p3;

// variables to represent whether a process has a token or not
// note they are global because they can be updated by other processes
global q1  : [0..1] init 0;
global q2  : [0..1] init 0;
global q3  : [0..1] init 0;

module initializer
  remaining : [0..k] init k;

  [] remaining>0 & q1=0 -> 1:(q1'=1) & (remaining'=remaining-1);
  [] remaining>0 & q2=0 -> 1:(q2'=1) & (remaining'=remaining-1);
  [] remaining>0 & q3=0 -> 1:(q3'=1) & (remaining'=remaining-1);

endmodule


// module of process 1
module process1
    
    [] (remaining=0) & (q1=1) -> p1 : (q1'=0) & (q3'=1) + 1-p1 : (q1'=0) & (q2'=1);
    
endmodule

// add further processes through renaming
module process2 = process1 [ q1=q2, q2=q3, q3=q1, p1=p2 ] endmodule
module process3 = process1 [ q1=q3, q2=q1, q3=q2, p1=p3 ] endmodule


// cost - 1 in each state (expected steps)
rewards "steps"
    true : 1;
endrewards

// formula, for use here and in properties: number of tokens
formula num_tokens = q1+q2+q3;

label "stable" = remaining=0 & num_tokens = 1;
