// Israeli-Jalfon self stabilising algorithm
// dxp/gxn 10/06/02

dtmc

const double p1;
const double p2;
const double p3;
const double p4;
const double p5;

// variables to represent whether a process has a token or not
// note they are global because they can be updated by other processes
global q1  : [0..1] init 1;
global q2  : [0..1] init 1;
global q3  : [0..1] init 1;
global q4  : [0..1] init 1;
global q5  : [0..1] init 1;

// module of process 1
module process1
    
    [] (q1=1) -> p1 : (q1'=0) & (q3'=1) + 1-p1 : (q1'=0) & (q2'=1);
    
endmodule

// add further processes through renaming
module process2 = process1 [ q1=q2, q2=q3, q3=q1, p1=p2 ] endmodule
module process3 = process1 [ q1=q3, q2=q4, q3=q2, p1=p3 ] endmodule
module process4 = process1 [ q1=q4, q2=q5, q3=q3, p1=p4 ] endmodule
module process5 = process1 [ q1=q5, q2=q1, q3=q4, p1=p5 ] endmodule


// cost - 1 in each state (expected steps)
rewards "steps"
    true : 1;
endrewards

// formula, for use here and in properties: number of tokens
formula num_tokens = q1+q2+q3+q4+q5;

label "stable" = num_tokens = 1;
